## GUnixFDList GUnixFDList — An object containing a set of UNIX file descriptors |

## Functions

GUnixFDList * | g_unix_fd_list_new_from_array ()
GUnixFDList * | g_unix_fd_list_new ()
gint | g_unix_fd_list_get_length ()
gint | g_unix_fd_list_get ()
const gint * | g_unix_fd_list_peek_fds ()
gint * | g_unix_fd_list_steal_fds ()
gint | g_unix_fd_list_append ()

## Types and Values

| GUnixFDList

## Object Hierarchy

        GObject
        ╰── GUnixFDList

## Includes

    #include <gio/gunixfdlist.h>

## Description

A GUnixFDList contains a list of file descriptors. It owns the file descriptors that it contains, closing them when finalized.

It may be wrapped in a GUnixFDMessage and sent over a GSocket in the `G_SOCKET_ADDRESS_UNIX` family by using `g_socket_send_message()` and received using `g_socket_receive_message()`.

Note that `<gio/gunixfdlist.h>` belongs to the UNIX-specific GIO interfaces, thus you have to use the `gio-unix-2.0.pc` pkg-config file when using it.

## Functions

### g_unix_fd_list_new_from_array ()

    GUnixFDList *
    g_unix_fd_list_new_from_array (const gint *fds,
                                   gint n_fds);

Creates a new GUnixFDList containing the file descriptors given in `fds` . The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

If `n_fds` is -1 then `fds` must be terminated with -1.

#### Parameters

fds | the initial list of file descriptors. | [array length=n_fds]
n_fds | the length of fds, or -1 |

#### Returns

a new GUnixFDList

Since 2.24

### g_unix_fd_list_new ()

    GUnixFDList *
    g_unix_fd_list_new (void);

Creates a new GUnixFDList containing no file descriptors.

#### Returns

a new GUnixFDList

Since 2.24

### g_unix_fd_list_get_length ()

    gint
    g_unix_fd_list_get_length (GUnixFDList *list);

Gets the length of `list` (ie: the number of file descriptors contained within).

#### Parameters

list | a GUnixFDList |

#### Returns

the length of `list`

Since 2.24

### g_unix_fd_list_get ()

    gint
    g_unix_fd_list_get (GUnixFDList *list,
                        gint index_,
                        GError **error);

Gets a file descriptor out of `list` .

`index_` specifies the index of the file descriptor to get. It is a programmer error for `index_` to be out of range; see `g_unix_fd_list_get_length()`.

The file descriptor is duplicated using `dup()` and set as close-on-exec before being returned. You must call `close()` on it when you are done.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

#### Parameters

list | a GUnixFDList |
index_ | the index into the list |
error | a GError pointer |

#### Returns

the file descriptor, or -1 in case of error

Since 2.24

### g_unix_fd_list_peek_fds ()

    const gint *
    g_unix_fd_list_peek_fds (GUnixFDList *list,
                             gint *length);

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors remain the property of `list` . The caller must not close them and must not free the array. The array is valid only until `list` is changed in any way.

If `length` is non-`NULL` then it is set to the number of file descriptors in the returned array. The returned array is also terminated with -1.

This function never returns `NULL`. In case there are no file descriptors contained in `list` , an empty array is returned.

#### Parameters

list | a GUnixFDList |
length | pointer to the length of the returned array, or `NULL`. | [out][allow-none]

#### Returns

an array of file descriptors.

[array length=length][transfer none]

Since 2.24

### g_unix_fd_list_steal_fds ()

    gint *
    g_unix_fd_list_steal_fds (GUnixFDList *list,
                              gint *length);

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors are no longer contained in `list` . Further calls will return an empty list (unless more descriptors have been added).

The return result of this function must be freed with `g_free()`. The caller is also responsible for closing all of the file descriptors. The file descriptors in the array are set to close-on-exec.

If `length` is non-`NULL` then it is set to the number of file descriptors in the returned array. The returned array is also terminated with -1.

This function never returns `NULL`. In case there are no file descriptors contained in `list` , an empty array is returned.

#### Parameters

list | a GUnixFDList |
length | pointer to the length of the returned array, or `NULL`. | [out][allow-none]

#### Returns

an array of file descriptors.

[array length=length][transfer full]

Since 2.24

### g_unix_fd_list_append ()

    gint
    g_unix_fd_list_append (GUnixFDList *list,
                           gint fd,
                           GError **error);

Adds a file descriptor to `list` .

The file descriptor is duplicated using `dup()`. You keep your copy of the descriptor and the copy contained in `list` will be closed when `list` is finalized.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

The index of the file descriptor in the list is returned. If you use this index with `g_unix_fd_list_get()` then you will receive back a duplicated copy of the same file descriptor.

#### Parameters

list | a GUnixFDList |
fd | a valid open file descriptor |
error | a GError pointer |

#### Returns

the index of the appended fd in case of success, else -1 (and `error` is set)

Since 2.24

## Types and Values

### GUnixFDList

    typedef struct _GUnixFDList GUnixFDList;

GUnixFDList is an opaque data structure and can only be accessed using the following functions.

## See Also

GUnixFDMessage